#include <avr/io.h>
#include <avr/interrupt.h>

const uint8_t dataporta[] = { 0xFE, 0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F};
const uint8_t dataportb[] = { 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F};
const uint8_t dataportd[] = { 0xEF, 0xDF, 0xBF, 0x7F};

ISR (TIMER0_COMPA_vect)
{
  static uint8_t col = 0;

  switch (col) {
     case 0:
     case 1:
     case 2:
     case 3:
       PORTD &= dataportd[col];
       break;
     case 4:
     case 5:
     case 6:
     case 7:
     case 8:
     case 9:
       col = col - 4;
       PORTB &= dataportb[col];
       break;
     case 10:
     case 11:
     case 12:
     case 13:
     case 14:
     case 15:
     case 16:
     case 17:
       col = col - 10;
       PORTA &= dataporta[col];
       break;
  }

  col += 1;
  if (col == 18)
    col = 0;
}

